<template>
  <!-- Start Content-->
  <div class="container-fluid">

    <!-- start page title -->
    <div class="row">
      <div class="col-12">
        <div class="page-title-box">
          <h4 class="page-title">Информация о товаре</h4>
        </div>
      </div>
    </div>
    <!-- end page title -->

    <div class="row">
      <div class="col-12">
        <div class="card-box">
          <div class="row">
            <div class="col-lg-5">

              <div class="tab-content pt-0">
                <template v-if="images.length > 0">
                  <div class="tab-pane" :class="[key == 0 ? 'active show' : '']" :id="'product-' + (image.id) +'-item'" v-for="(image, key) in images">
                    <img :src="'http://site.test/storage/' + image.id + '/' + image.file_name" alt="" class="img-fluid mx-auto d-block rounded">
                  </div>
                </template>
                <template v-else>
                  <div class="tab-pane active show">
                    <img :src="'/assets/images/products/default.jpg'" alt="" class="img-fluid mx-auto d-block rounded">
                  </div>
                </template>
              </div>

              <ul class="nav nav-pills nav-justified" v-if="images.length > 1">
                <li class="nav-item" v-for="(image, key) in images">
                  <a :href="'#product-'+ (image.id) + '-item'" data-toggle="tab" aria-expanded="false" class="nav-link product-thumb" :class="[key == 0 ? 'active show' : '']">
                    <img :src="image.original_url" alt="" class="img-fluid mx-auto d-block rounded">
                  </a>
                </li>
              </ul>
            </div> <!-- end col -->
            <div class="col-lg-7">
              <div class="pl-xl-3 mt-3 mt-xl-0">
                <a href="#" class="text-primary">{{ brand }}</a>
                <h4 class="mb-3">{{ product_name }}
                  <span class="badge badge-success" v-if="status == 'new'">Новинка</span>
                  <span class="badge badge-danger" v-else-if="status == 'promo'">Акция!</span>
                  <span class="badge badge-blue" v-else-if="status == 'recommended'">Рекомендуемое!</span>
                  <span class="badge badge-info" v-else-if="status == 'repeat'">Ожидается в повторе</span>
                  <span class="badge badge-info" v-else-if="status == 'preorder'">Доступно по предзаказу</span>
                </h4>
                <div class="alert alert-success" role="alert" v-show="saveCartSuccess">
                  <i class="mdi mdi-check-all mr-2"></i> Товар успешно добавлен в корзину!
                </div>
                <h6 class="text-danger text-uppercase" v-if="typeof discount != 'undefined' && discount > 0 && is_percent">Скидка {{ discount * 100 }} %</h6>
                <h6 class="text-danger text-uppercase" v-else-if="typeof discount != 'undefined' && discount > 0 && !is_percent">Скидка {{ discount }} р.</h6>
                <h4 class="mb-4" v-if="distributor.length > 0 && distributor[0].status == 'success' || is_manufacturer">Оптовая цена: <span class="text-muted mr-2" v-if="typeof discount != 'undefined' && discount > 0"><del>{{ price }}</del></span>
                  <b v-if="typeof discount != 'undefined' && discount > 0 && is_percent">{{ price - price * discount}} р.</b>
                  <b v-else-if="typeof discount != 'undefined' && discount > 0 && !is_percent">{{ price - discount}} р.</b>
                  <b v-else>{{ price }}</b>
                </h4>
                <h4 class="mb-4" v-if="distributor.length > 0 && distributor[0].status != 'success' || is_manufacturer">Розничная цена: <span class="text-muted mr-2" v-if="typeof discount != 'undefined' && discount > 0"><del>{{ recommended_retail_price }}</del></span>
                  <b v-if="typeof discount != 'undefined' && discount > 0 && is_percent">{{ recommended_retail_price - recommended_retail_price * discount}} р.</b>
                  <b v-else-if="typeof discount != 'undefined' && discount > 0 && !is_percent">{{ recommended_retail_price - discount}} р.</b>
                  <b v-else>{{ recommended_retail_price }} р.</b>
                </h4>

                <h4 v-if="stock > 4"><span class="badge bg-soft-success text-success mb-4">В наличии {{ stock }} шт.</span></h4>
                <h4 v-else-if="stock > 0"><span class="badge bg-soft-success text-success mb-4">Осталось {{ stock }} шт.</span></h4>
                <h4 v-else-if="status = 'preorder'"><span class="badge bg-soft-success text-success mb-4">Предзаказ</span></h4>
                <h4 v-else-if="status = 'repeat'"><span class="badge bg-soft-success text-success mb-4">Ожидается в повторе</span></h4>
                <div class="form-group mb-3" v-if="description != ''">
                  <label>Описание</label>
                  <p class="text-muted mb-4">{{ description }}</p>
                </div>
                <div class="form-group mb-3" v-if="consist != ''">
                  <label>Состав</label>
                  <p class="text-muted mb-4">{{ consist }}</p>
                </div>
                <div class="form-group mb-3" v-if="distributor.length > 0 && distributor[0].status == 'success' || is_manufacturer">
                  <label>Размеры</label>
                  <div class="form-group row mb-3" v-for="(size) in sizes">
                    <label class="col-form-label col-sm-1">{{ size.title }}</label>
                    <div class="col-sm-2" v-if="!is_manufacturer">
                      <input type="text" :name="size.value" class="form-control" :ref="size.value" placeholder="0" @change="currentSizes($event, size.stock)">
                    </div>
                    <label class="col-form-label col-sm-1" v-if="!is_manufacturer">шт.</label>
                    <span class="col-form-label col-sm-2">Доступно: {{size.stock}} шт.</span>
                  </div>
                </div>
                <div v-if="!is_manufacturer && distributor.length == 0">
                  <p class="text-muted mb-4">Для заказа товара и выбора количества сперва запросите цену. После того, как поставщик одобрит заявку, вам будет доступно количество позиций и оформление заказа</p>
                </div>


                <div v-if="!is_manufacturer">
                  <button type="button" class="btn btn-success waves-effect waves-light" @click.prevent="saveCart()" v-if="distributor.length > 0 && distributor[0].status == 'success'" :disabled="isDisabledButton">
                    <span class="btn-label"><i class="mdi mdi-cart"></i></span>Добавить в заказ
                  </button>
                  <button type="button" class="btn btn-success waves-effect waves-light disabled"  v-else-if="distributor.length > 0 && distributor[0].status == 'new'">
                    <span class="btn-label"><i class="mdi mdi-cart"></i></span>Запрошено
                  </button>
                  <button type="button" class="btn btn-success waves-effect waves-light"  @click.prevent="sendRequestPrice()" v-else>
                    <span class="btn-label"><i class="mdi mdi-cart"></i></span>Запросить цены
                  </button>
                </div>
              </div>
            </div> <!-- end col -->
          </div>
          <!-- end row -->

        </div> <!-- end card-->
      </div> <!-- end col-->
    </div>
    <!-- end row-->

  </div> <!-- container -->
</template>

<script>
export default {
  name: "index",
  data() {
    return {
        product: {},
        product_id: 0,
        brand: '',
        company_id: 0,
        product_name: '',
        images: '',
        is_manufacturer: '',
        is_percent: '',
        discount: 0,
        distributor: {},
        price: 0,
        recommended_retail_price: 0,
        stock: 0,
        status: '',
        currentSelectedSizes: {},
        consist: '',
        description: '',
        isSucccess: false,
        isDisabledButton: false,
        sizes: []
      }
  },
  created () {
    this.$axios.post('/products/show',{
      'slug' : this.$route.params.slug
    })
      .then(resp => {
        this.product = resp.data;
        this.product_id = resp.data.product.id;
        this.company_id = resp.data.product.company_id;
        this.brand = resp.data.brand.brand;
        this.product_name = resp.data.product.name;
        this.discount = resp.data.discount;
        this.images = resp.data.product.media;
        this.is_manufacturer = resp.data.is_manufacturer;
        this.is_percent = resp.data.is_percent;
        this.distributor = resp.data.distributor;
        this.price = resp.data.product.price;
        this.recommended_retail_price = resp.data.product.recommended_retail_price;
        this.stock = resp.data.product.stock;
        this.status = resp.data.product.status;
        this.description = resp.data.product.description;
        this.consist = resp.data.product.consist;
        this.sizes = resp.data.properties.size;
      }).catch(function(){
      console.log('Error 123');
    });
  },
  computed:{
    saveCartSuccess: function(){
      return this.isSucccess;
    }
  },
  methods:{
    sendRequestPrice(){
      this.$axios.post('/price/request',{
        'company_id' : this.company_id
      })
        .then(resp => {
          this.distributor = resp.data;
        }).catch(function(){
        console.log('Error request');
      });
    },
    saveCart(){
      this.isDisabledButton = true;
      this.$axios.post('/carts/save',{
        'product_id' : this.product_id,
        'sizes': this.currentSelectedSizes
      })
        .then(resp => {
            this.isSucccess = true;
            this.isDisabledButton = false;
            this.sizes = resp.data.sizes;
            this.stock = resp.data.stock;
        }).catch(function(){
        console.log('Error request');
      });
    },
    currentSizes(el, stock){
      if(el.target.value > stock){
        this.currentSelectedSizes[el.target.name] = stock;
        el.target.value = stock;
      }else if(el.target.value < 0){
        el.target.value = 0;
      }else{
        this.currentSelectedSizes[el.target.name] = el.target.value;
      }
    },
  }
}
</script>

<style scoped>

</style>
